Index: uspace/drv/bus/usb/usbmast/scsi_ms.c
===================================================================
--- uspace/drv/bus/usb/usbmast/scsi_ms.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/drv/bus/usb/usbmast/scsi_ms.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -46,7 +46,8 @@
 #include <scsi/sbc.h>
 #include <scsi/spc.h>
-#include "cmds.h"
-#include "mast.h"
+#include "cmdw.h"
+#include "bo_trans.h"
 #include "scsi_ms.h"
+#include "usbmast.h"
 
 /** Get string representation for SCSI peripheral device type.
@@ -62,9 +63,9 @@
 /** Perform SCSI Inquiry command on USB mass storage device.
  *
- * @param dev		USB device.
- * @param inquiry_result Where to store parsed inquiry result.
- * @return		Error code.
- */
-int usbmast_inquiry(usb_device_t *dev, usbmast_inquiry_data_t *inq_res)
+ * @param mfun		Mass storage function
+ * @param inquiry_result Where to store parsed inquiry result
+ * @return		Error code
+ */
+int usbmast_inquiry(usbmast_fun_t *mfun, usbmast_inquiry_data_t *inq_res)
 {
 	scsi_std_inquiry_data_t inq_data;
@@ -77,10 +78,10 @@
 	cdb.alloc_len = host2uint16_t_be(sizeof(inq_data));
 
-	rc = usb_massstor_data_in(dev, 0xDEADBEEF, 0, (uint8_t *) &cdb,
+	rc = usb_massstor_data_in(mfun, 0xDEADBEEF, (uint8_t *) &cdb,
 	    sizeof(cdb), &inq_data, sizeof(inq_data), &response_len);
 
 	if (rc != EOK) {
 		usb_log_error("Inquiry failed, device %s: %s.\n",
-		   dev->ddf_dev->name, str_error(rc));
+		   mfun->mdev->ddf_dev->name, str_error(rc));
 		return rc;
 	}
@@ -118,5 +119,5 @@
 /** Perform SCSI Request Sense command on USB mass storage device.
  *
- * @param dev		USB device
+ * @param mfun		Mass storage function
  * @param buf		Destination buffer
  * @param size		Size of @a buf
@@ -124,5 +125,5 @@
  * @return		Error code.
  */
-int usbmast_request_sense(usb_device_t *dev, void *buf, size_t size)
+int usbmast_request_sense(usbmast_fun_t *mfun, void *buf, size_t size)
 {
 	scsi_cdb_request_sense_t cdb;
@@ -134,10 +135,10 @@
 	cdb.alloc_len = min(size, SCSI_SENSE_DATA_MAX_SIZE);
 
-	rc = usb_massstor_data_in(dev, 0xDEADBEEF, 0, (uint8_t *) &cdb,
+	rc = usb_massstor_data_in(mfun, 0xDEADBEEF, (uint8_t *) &cdb,
 	    sizeof(cdb), buf, size, &data_len);
 
         if (rc != EOK) {
 		usb_log_error("Request Sense failed, device %s: %s.\n",
-		   dev->ddf_dev->name, str_error(rc));
+		   mfun->mdev->ddf_dev->name, str_error(rc));
 		return rc;
 	}
@@ -154,11 +155,11 @@
 /** Perform SCSI Read Capacity command on USB mass storage device.
  *
- * @param dev		USB device.
- * @param nblocks	Output, number of blocks.
- * @param block_size	Output, block size in bytes.
+ * @param mfun		Mass storage function
+ * @param nblocks	Output, number of blocks
+ * @param block_size	Output, block size in bytes
  *
  * @return		Error code.
  */
-int usbmast_read_capacity(usb_device_t *dev, uint32_t *nblocks,
+int usbmast_read_capacity(usbmast_fun_t *mfun, uint32_t *nblocks,
     uint32_t *block_size)
 {
@@ -171,10 +172,10 @@
 	cdb.op_code = SCSI_CMD_READ_CAPACITY_10;
 
-	rc = usb_massstor_data_in(dev, 0xDEADBEEF, 0, (uint8_t *) &cdb,
+	rc = usb_massstor_data_in(mfun, 0xDEADBEEF, (uint8_t *) &cdb,
 	    sizeof(cdb), &data, sizeof(data), &data_len);
 
         if (rc != EOK) {
 		usb_log_error("Read Capacity (10) failed, device %s: %s.\n",
-		   dev->ddf_dev->name, str_error(rc));
+		   mfun->mdev->ddf_dev->name, str_error(rc));
 		return rc;
 	}
@@ -194,13 +195,11 @@
 /** Perform SCSI Read command on USB mass storage device.
  *
- * @param dev		USB device.
- * @param ba		Address of first block.
- * @param nblocks	Number of blocks to read.
- * @param bsize		Block size.
- *
- * @return		Error code.
- */
-int usbmast_read(usb_device_t *dev, uint64_t ba, size_t nblocks, size_t bsize,
-    void *buf)
+ * @param mfun		Mass storage function
+ * @param ba		Address of first block
+ * @param nblocks	Number of blocks to read
+ *
+ * @return		Error code
+ */
+int usbmast_read(usbmast_fun_t *mfun, uint64_t ba, size_t nblocks, void *buf)
 {
 	scsi_cdb_read_12_t cdb;
@@ -213,5 +212,5 @@
 		return ELIMIT;
 
-	if ((uint64_t)nblocks * bsize > UINT32_MAX)
+	if ((uint64_t)nblocks * mfun->block_size > UINT32_MAX)
 		return ELIMIT;
 
@@ -221,14 +220,14 @@
 	cdb.xfer_len = host2uint32_t_be(nblocks);
 
-	rc = usb_massstor_data_in(dev, 0xDEADBEEF, 0, (uint8_t *) &cdb,
-	    sizeof(cdb), buf, nblocks * bsize, &data_len);
+	rc = usb_massstor_data_in(mfun, 0xDEADBEEF, (uint8_t *) &cdb,
+	    sizeof(cdb), buf, nblocks * mfun->block_size, &data_len);
 
         if (rc != EOK) {
 		usb_log_error("Read (12) failed, device %s: %s.\n",
-		   dev->ddf_dev->name, str_error(rc));
-		return rc;
-	}
-
-	if (data_len < nblocks * bsize) {
+		   mfun->mdev->ddf_dev->name, str_error(rc));
+		return rc;
+	}
+
+	if (data_len < nblocks * mfun->block_size) {
 		usb_log_error("SCSI Read response too short (%zu).\n",
 		    data_len);
@@ -241,13 +240,12 @@
 /** Perform SCSI Write command on USB mass storage device.
  *
- * @param dev		USB device
+ * @param mfun		Mass storage function
  * @param ba		Address of first block
  * @param nblocks	Number of blocks to read
- * @param bsize		Block size
  * @param data		Data to write
  *
  * @return		Error code
  */
-int usbmast_write(usb_device_t *dev, uint64_t ba, size_t nblocks, size_t bsize,
+int usbmast_write(usbmast_fun_t *mfun, uint64_t ba, size_t nblocks,
     const void *data)
 {
@@ -256,10 +254,8 @@
 	int rc;
 
-	/* XXX Need softstate to store block size. */
-
 	if (ba > UINT32_MAX)
 		return ELIMIT;
 
-	if ((uint64_t)nblocks * bsize > UINT32_MAX)
+	if ((uint64_t)nblocks * mfun->block_size > UINT32_MAX)
 		return ELIMIT;
 
@@ -269,14 +265,14 @@
 	cdb.xfer_len = host2uint32_t_be(nblocks);
 
-	rc = usb_massstor_data_out(dev, 0xDEADBEEF, 0, (uint8_t *) &cdb,
-	    sizeof(cdb), data, nblocks * bsize, &sent_len);
+	rc = usb_massstor_data_out(mfun, 0xDEADBEEF, (uint8_t *) &cdb,
+	    sizeof(cdb), data, nblocks * mfun->block_size, &sent_len);
 
         if (rc != EOK) {
 		usb_log_error("Write (12) failed, device %s: %s.\n",
-		   dev->ddf_dev->name, str_error(rc));
-		return rc;
-	}
-
-	if (sent_len < nblocks * bsize) {
+		   mfun->mdev->ddf_dev->name, str_error(rc));
+		return rc;
+	}
+
+	if (sent_len < nblocks * mfun->block_size) {
 		usb_log_error("SCSI Write not all bytes transferred (%zu).\n",
 		    sent_len);
Index: uspace/drv/bus/usb/usbmast/scsi_ms.h
===================================================================
--- uspace/drv/bus/usb/usbmast/scsi_ms.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/drv/bus/usb/usbmast/scsi_ms.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -59,10 +59,9 @@
 } usbmast_inquiry_data_t;
 
-extern int usbmast_inquiry(usb_device_t *, usbmast_inquiry_data_t *);
-extern int usbmast_request_sense(usb_device_t *, void *, size_t);
-extern int usbmast_read_capacity(usb_device_t *, uint32_t *, uint32_t *);
-extern int usbmast_read(usb_device_t *, uint64_t, size_t, size_t, void *);
-extern int usbmast_write(usb_device_t *, uint64_t, size_t, size_t,
-    const void *);
+extern int usbmast_inquiry(usbmast_fun_t *, usbmast_inquiry_data_t *);
+extern int usbmast_request_sense(usbmast_fun_t *, void *, size_t);
+extern int usbmast_read_capacity(usbmast_fun_t *, uint32_t *, uint32_t *);
+extern int usbmast_read(usbmast_fun_t *, uint64_t, size_t, void *);
+extern int usbmast_write(usbmast_fun_t *, uint64_t, size_t, const void *);
 extern const char *usbmast_scsi_dev_type_str(unsigned);
 
Index: uspace/drv/bus/usb/usbmast/usbmast.h
===================================================================
--- uspace/drv/bus/usb/usbmast/usbmast.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
+++ uspace/drv/bus/usb/usbmast/usbmast.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -0,0 +1,73 @@
+/*
+ * Copyright (c) 2011 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbmast
+ * @{
+ */
+/** @file
+ * USB mass storage commands.
+ */
+
+#ifndef USBMAST_H_
+#define USBMAST_H_
+
+#include <sys/types.h>
+#include <usb/usb.h>
+
+/** Mass storage device. */
+typedef struct {
+	/** DDF device */
+	ddf_dev_t *ddf_dev;
+	/** USB device */
+	usb_device_t *usb_dev;
+	/** Number of LUNs */
+	unsigned luns;
+} usbmast_dev_t;
+
+/** Mass storage function.
+ *
+ * Serves as soft state for function/LUN.
+ */
+typedef struct {
+	/** Mass storage device the function belongs to */
+	usbmast_dev_t *mdev;
+	/** DDF function */
+	ddf_fun_t *ddf_fun;
+	/** LUN */
+	unsigned lun;
+	/** Total number of blocks */
+	uint64_t nblocks;
+	/** Block size in bytes */
+	size_t block_size;
+} usbmast_fun_t;
+
+#endif
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/vhc/connhost.c
===================================================================
--- uspace/drv/bus/usb/vhc/connhost.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/drv/bus/usb/vhc/connhost.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -141,19 +141,14 @@
     size_t max_packet_size, unsigned int interval)
 {
-	VHC_DATA(vhc, fun);
-
-	endpoint_t *ep = malloc(sizeof(endpoint_t));
+	/* TODO: Use usb_endpoint_manager_add_ep */
+	VHC_DATA(vhc, fun);
+
+	endpoint_t *ep = endpoint_get(
+	    address, endpoint, direction, transfer_type, USB_SPEED_FULL, 1);
 	if (ep == NULL) {
 		return ENOMEM;
 	}
 
-	int rc = endpoint_init(ep, address, endpoint, direction, transfer_type,
-	    USB_SPEED_FULL, 1);
-	if (rc != EOK) {
-		free(ep);
-		return rc;
-	}
-
-	rc = usb_endpoint_manager_register_ep(&vhc->ep_manager, ep, 1);
+	int rc = usb_endpoint_manager_register_ep(&vhc->ep_manager, ep, 1);
 	if (rc != EOK) {
 		endpoint_destroy(ep);
Index: uspace/drv/infrastructure/root/root.c
===================================================================
--- uspace/drv/infrastructure/root/root.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/drv/infrastructure/root/root.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -176,4 +176,6 @@
 	}
 
+	free(match_id);
+
 	rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
Index: uspace/drv/test/test1/test1.c
===================================================================
--- uspace/drv/test/test1/test1.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/drv/test/test1/test1.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -74,5 +74,5 @@
 	}
 
-	rc = ddf_fun_add_match_id(fun, str_dup(match_id), match_score);
+	rc = ddf_fun_add_match_id(fun, match_id, match_score);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed adding match IDs to function %s",
Index: uspace/lib/c/generic/io/io.c
===================================================================
--- uspace/lib/c/generic/io/io.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/c/generic/io/io.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -714,4 +714,5 @@
 off64_t ftell(FILE *stream)
 {
+	_fflushbuf(stream);
 	return lseek(stream->fd, 0, SEEK_CUR);
 }
Index: uspace/lib/clui/tinput.c
===================================================================
--- uspace/lib/clui/tinput.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/clui/tinput.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -27,4 +27,5 @@
  */
 
+#include <sort.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -42,4 +43,7 @@
 #include <tinput.h>
 
+#define LIN_TO_COL(ti, lpos) ((lpos) % ((ti)->con_cols))
+#define LIN_TO_ROW(ti, lpos) ((lpos) / ((ti)->con_cols))
+
 /** Seek direction */
 typedef enum {
@@ -61,4 +65,10 @@
 static void tinput_post_seek(tinput_t *, bool);
 
+static void tinput_console_set_lpos(tinput_t *ti, unsigned lpos)
+{
+	console_set_pos(ti->console, LIN_TO_COL(ti, lpos),
+	    LIN_TO_ROW(ti, lpos));
+}
+
 /** Create a new text input field. */
 tinput_t *tinput_new(void)
@@ -66,5 +76,5 @@
 	tinput_t *ti;
 	
-	ti = malloc(sizeof(tinput_t));
+	ti = calloc(1, sizeof(tinput_t));
 	if (ti == NULL)
 		return NULL;
@@ -77,5 +87,17 @@
 void tinput_destroy(tinput_t *ti)
 {
+	if (ti->prompt != NULL)
+		free(ti->prompt);
 	free(ti);
+}
+
+static void tinput_display_prompt(tinput_t *ti)
+{
+	tinput_console_set_lpos(ti, ti->prompt_coord);
+
+	console_set_style(ti->console, STYLE_EMPHASIS);
+	printf("%s", ti->prompt);
+	console_flush(ti->console);
+	console_set_style(ti->console, STYLE_NORMAL);
 }
 
@@ -88,6 +110,5 @@
 	tinput_sel_get_bounds(ti, &sa, &sb);
 	
-	console_set_pos(ti->console, (ti->col0 + start) % ti->con_cols,
-	    ti->row0 + (ti->col0 + start) / ti->con_cols);
+	tinput_console_set_lpos(ti, ti->text_coord + start);
 	console_set_style(ti->console, STYLE_NORMAL);
 	
@@ -134,17 +155,45 @@
 static void tinput_position_caret(tinput_t *ti)
 {
-	console_set_pos(ti->console, (ti->col0 + ti->pos) % ti->con_cols,
-	    ti->row0 + (ti->col0 + ti->pos) / ti->con_cols);
-}
-
-/** Update row0 in case the screen could have scrolled. */
+	tinput_console_set_lpos(ti, ti->text_coord + ti->pos);
+}
+
+/** Update text_coord, prompt_coord in case the screen could have scrolled. */
 static void tinput_update_origin(tinput_t *ti)
 {
-	sysarg_t width = ti->col0 + ti->nc;
-	sysarg_t rows = (width / ti->con_cols) + 1;
-	
-	/* Update row0 if the screen scrolled. */
-	if (ti->row0 + rows > ti->con_rows)
-		ti->row0 = ti->con_rows - rows;
+	unsigned end_coord = ti->text_coord + ti->nc;
+	unsigned end_row = LIN_TO_ROW(ti, end_coord);
+
+	unsigned scroll_rows;
+
+	/* Update coords if the screen scrolled. */
+	if (end_row >= ti->con_rows) {
+		scroll_rows = end_row - ti->con_rows + 1;
+		ti->text_coord -= ti->con_cols * scroll_rows;
+		ti->prompt_coord -= ti->con_cols * scroll_rows;
+	}
+}
+
+static void tinput_jump_after(tinput_t *ti)
+{
+	tinput_console_set_lpos(ti, ti->text_coord + ti->nc);
+	console_flush(ti->console);
+	putchar('\n');
+}
+
+static int tinput_display(tinput_t *ti)
+{
+	sysarg_t col0, row0;
+	
+	if (console_get_pos(ti->console, &col0, &row0) != EOK)
+		return EIO;
+	
+	ti->prompt_coord = row0 * ti->con_cols + col0;
+	ti->text_coord = ti->prompt_coord + str_length(ti->prompt);
+
+	tinput_display_prompt(ti);
+	tinput_display_tail(ti, 0, 0);
+	tinput_position_caret(ti);
+
+	return EOK;
 }
 
@@ -154,5 +203,5 @@
 		return;
 	
-	sysarg_t new_width = ti->col0 + ti->nc + 1;
+	unsigned new_width = LIN_TO_COL(ti, ti->text_coord) + ti->nc + 1;
 	if (new_width % ti->con_cols == 0) {
 		/* Advancing to new line. */
@@ -185,6 +234,6 @@
 		return;
 	
-	sysarg_t new_width = ti->col0 + ti->nc + ilen;
-	sysarg_t new_height = (new_width / ti->con_cols) + 1;
+	unsigned new_width = LIN_TO_COL(ti, ti->text_coord) + ti->nc + ilen;
+	unsigned new_height = (new_width / ti->con_cols) + 1;
 	if (new_height >= ti->con_rows) {
 		/* Disallow text longer than 1 page for now. */
@@ -511,4 +560,141 @@
 }
 
+/** Compare two entries in array of completions. */
+static int compl_cmp(void *va, void *vb, void *arg)
+{
+	const char *a = *(const char **) va;
+	const char *b = *(const char **) vb;
+
+	return str_cmp(a, b);
+}
+
+static size_t common_pref_len(const char *a, const char *b)
+{
+	size_t i;
+	size_t a_off, b_off;
+	wchar_t ca, cb;
+
+	i = 0;
+	a_off = 0;
+	b_off = 0;
+
+	while (true) {
+		ca = str_decode(a, &a_off, STR_NO_LIMIT);
+		cb = str_decode(b, &b_off, STR_NO_LIMIT);
+
+		if (ca == '\0' || cb == '\0' || ca != cb)
+			break;
+		++i;
+	}
+
+	return i;
+}
+
+static void tinput_text_complete(tinput_t *ti)
+{
+	void *state;
+	size_t cstart;
+	char *ctmp;
+	char **compl;     	/* Array of completions */
+	size_t compl_len;	/* Current length of @c compl array */
+	size_t cnum;
+	size_t i;
+	int rc;
+
+	if (ti->compl_ops == NULL)
+		return;
+
+	/*
+	 * Obtain list of all possible completions (growing array).
+	 */
+
+	rc = (*ti->compl_ops->init)(ti->buffer, ti->pos, &cstart, &state);
+	if (rc != EOK)
+		return;
+
+	cnum = 0;
+
+	compl_len = 1;
+	compl = malloc(compl_len * sizeof(char *));
+	if (compl == NULL) {
+		printf("Error: Out of memory.\n");
+		return;
+	}
+
+	while (true) {
+		rc = (*ti->compl_ops->get_next)(state, &ctmp);
+		if (rc != EOK)
+			break;
+
+		if (cnum >= compl_len) {
+			/* Extend array */
+			compl_len = 2 * compl_len;
+			compl = realloc(compl, compl_len * sizeof(char *));
+			if (compl == NULL) {
+				printf("Error: Out of memory.\n");
+				break;
+			}
+		}
+
+		compl[cnum] = str_dup(ctmp);
+		if (compl[cnum] == NULL) {
+			printf("Error: Out of memory.\n");
+			break;
+		}
+		cnum++;
+	}
+
+	(*ti->compl_ops->fini)(state);
+
+	if (cnum > 1) {
+		/*
+		 * More than one match. Determine maximum common prefix.
+		 */
+		size_t cplen;
+
+		cplen = str_length(compl[0]);
+		for (i = 1; i < cnum; i++)
+			cplen = min(cplen, common_pref_len(compl[0], compl[i]));
+
+		/* Compute how many bytes we should skip. */
+		size_t istart = str_lsize(compl[0], ti->pos - cstart);
+
+		if (cplen > istart) {
+			/* Insert common prefix. */
+
+			/* Copy remainder of common prefix. */
+			char *cpref = str_ndup(compl[0] + istart,
+			    str_lsize(compl[0], cplen - istart));
+
+			/* Insert it. */
+			tinput_insert_string(ti, cpref);
+			free(cpref);
+		} else {
+			/* No common prefix. Sort and display all entries. */
+
+			qsort(compl, cnum, sizeof(char *), compl_cmp, NULL);
+
+			tinput_jump_after(ti);
+			for (i = 0; i < cnum; i++)
+				printf("%s\n", compl[i]);
+			tinput_display(ti);
+		}
+	} else if (cnum == 1) {
+		/*
+		 * We have exactly one match. Insert it.
+		 */
+
+		/* Compute how many bytes of completion string we should skip. */
+		size_t istart = str_lsize(compl[0], ti->pos - cstart);
+
+		/* Insert remainder of completion string at current position. */
+		tinput_insert_string(ti, compl[0] + istart);
+	}
+
+	for (i = 0; i < cnum; i++)
+		free(compl[i]);
+	free(compl);
+}
+
 /** Initialize text input field.
  *
@@ -521,4 +707,33 @@
 	ti->hpos = 0;
 	ti->history[0] = NULL;
+}
+
+/** Set prompt string.
+ *
+ * @param ti		Text input
+ * @param prompt	Prompt string
+ *
+ * @return		EOK on success, ENOMEM if out of memory.
+ */
+int tinput_set_prompt(tinput_t *ti, const char *prompt)
+{
+	if (ti->prompt != NULL)
+		free(ti->prompt);
+	
+	ti->prompt = str_dup(prompt);
+	if (ti->prompt == NULL)
+		return ENOMEM;
+	
+	return EOK;
+}
+
+/** Set completion ops.
+ *
+ * Set pointer to completion ops structure that will be used for text
+ * completion.
+ */
+void tinput_set_compl_ops(tinput_t *ti, tinput_compl_ops_t *compl_ops)
+{
+	ti->compl_ops = compl_ops;
 }
 
@@ -539,7 +754,4 @@
 		return EIO;
 	
-	if (console_get_pos(ti->console, &ti->col0, &ti->row0) != EOK)
-		return EIO;
-	
 	ti->pos = 0;
 	ti->sel_start = 0;
@@ -549,4 +761,7 @@
 	ti->exit_clui = false;
 	
+	if (tinput_display(ti) != EOK)
+		return EIO;
+	
 	while (!ti->done) {
 		console_flush(ti->console);
@@ -714,4 +929,7 @@
 		tinput_history_seek(ti, -1);
 		break;
+	case KC_TAB:
+		tinput_text_complete(ti);
+		break;
 	default:
 		break;
Index: uspace/lib/clui/tinput.h
===================================================================
--- uspace/lib/clui/tinput.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/clui/tinput.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,11 +37,65 @@
 #define LIBCLUI_TINPUT_H_
 
-#include <stdio.h>
+#include <adt/list.h>
 #include <async.h>
 #include <inttypes.h>
 #include <io/console.h>
+#include <stdio.h>
 
 #define HISTORY_LEN     10
 #define INPUT_MAX_SIZE  1024
+
+/** Begin enumeration of text completions.
+ *
+ * When user requests text completion, tinput will call this function to start
+ * text completion operation. @a *cstart should be set to the position
+ * (character index) of the first character of the 'word' that is being
+ * completed. The resulting text is obtained by replacing the range of text
+ * starting at @a *cstart and ending at @a pos with the completion text.
+ *
+ * The function can pass information to the get_next and fini functions
+ * via @a state. The init function allocates the state object and stores
+ * a pointer to it to @a *state. The fini function destroys the state object.
+ *
+ * @param text		Current contents of edit buffer (null-terminated).
+ * @param pos		Current caret position.
+ * @param cstart	Output, position in text where completion begins from.
+ * @param state		Output, pointer to a client state object.
+ *
+ * @return		EOK on success, negative error code on failure.
+ */
+typedef int (*tinput_compl_init_fn)(wchar_t *text, size_t pos, size_t *cstart,
+    void **state);
+
+/** Obtain one text completion alternative.
+ *
+ * Upon success the function sets @a *compl to point to a string, the
+ * completion text. The caller (Tinput) should not modify or free the text.
+ * The pointer is only valid until the next invocation of any completion
+ * function.
+ *
+ * @param state		Pointer to state object created by the init funtion.
+ * @param compl		Output, the completion text, ownership retained.
+ *
+ * @return		EOK on success, negative error code on failure.
+ */
+typedef int (*tinput_compl_get_next_fn)(void *state, char **compl);
+
+
+/** Finish enumeration of text completions.
+ *
+ * The function must deallocate any state information allocated by the init
+ * function or temporary data allocated by the get_next function.
+ *
+ * @param state		Pointer to state object created by the init funtion.
+ */
+typedef void (*tinput_compl_fini_fn)(void *state);
+
+/** Text completion ops. */
+typedef struct {
+	tinput_compl_init_fn init;
+	tinput_compl_get_next_fn get_next;
+	tinput_compl_fini_fn fini;
+} tinput_compl_ops_t;
 
 /** Text input field (command line).
@@ -53,10 +107,17 @@
 	console_ctrl_t *console;
 	
+	/** Prompt string */
+	char *prompt;
+	
+	/** Completion ops. */
+	tinput_compl_ops_t *compl_ops;
+	
 	/** Buffer holding text currently being edited */
 	wchar_t buffer[INPUT_MAX_SIZE + 1];
 	
-	/** Screen coordinates of the top-left corner of the text field */
-	sysarg_t col0;
-	sysarg_t row0;
+	/** Linear position on screen where the prompt starts */
+	unsigned prompt_coord;
+	/** Linear position on screen where the text field starts */
+	unsigned text_coord;
 	
 	/** Screen dimensions */
@@ -90,4 +151,6 @@
 
 extern tinput_t *tinput_new(void);
+extern int tinput_set_prompt(tinput_t *, const char *);
+extern void tinput_set_compl_ops(tinput_t *, tinput_compl_ops_t *);
 extern void tinput_destroy(tinput_t *);
 extern int tinput_read(tinput_t *, char **);
Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/drv/generic/driver.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -620,5 +620,5 @@
 		return ENOMEM;
 	
-	match_id->id = match_id_str;
+	match_id->id = str_dup(match_id_str);
 	match_id->score = 90;
 	
Index: uspace/lib/posix/assert.h
===================================================================
--- uspace/lib/posix/assert.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/assert.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Program assertion.
  */
 
@@ -52,3 +52,2 @@
 /** @}
  */
-
Index: uspace/lib/posix/ctype.c
===================================================================
--- uspace/lib/posix/ctype.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/ctype.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Character classification.
  */
 
@@ -43,6 +43,6 @@
  * Checks whether character is a hexadecimal digit.
  *
- * @param c
- * @return
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
  */
 int posix_isxdigit(int c)
@@ -56,6 +56,6 @@
  * Checks whether character is a word separator.
  *
- * @param c
- * @return
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
  */
 int posix_isblank(int c)
@@ -67,6 +67,6 @@
  * Checks whether character is a control character.
  *
- * @param c
- * @return
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
  */
 int posix_iscntrl(int c)
@@ -78,6 +78,6 @@
  * Checks whether character is any printing character except space.
  *
- * @param c
- * @return
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
  */
 int posix_isgraph(int c)
@@ -89,6 +89,6 @@
  * Checks whether character is a printing character.
  *
- * @param c
- * @return
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
  */
 int posix_isprint(int c)
@@ -100,10 +100,10 @@
  * Checks whether character is a punctuation.
  *
- * @param c
- * @return
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
  */
 int posix_ispunct(int c)
 {
-	return !isspace(c) && !isalnum(c);
+	return !isspace(c) && !isalnum(c) && posix_isprint(c);
 }
 
@@ -111,6 +111,6 @@
  * Checks whether character is ASCII. (obsolete)
  *
- * @param c
- * @return
+ * @param c Character to inspect.
+ * @return Non-zero if character match the definition, zero otherwise.
  */
 extern int posix_isascii(int c)
@@ -122,6 +122,6 @@
  * Converts argument to a 7-bit ASCII character. (obsolete)
  *
- * @param c
- * @return
+ * @param c Character to convert.
+ * @return Coverted character.
  */
 extern int posix_toascii(int c)
Index: uspace/lib/posix/ctype.h
===================================================================
--- uspace/lib/posix/ctype.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/ctype.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Character classification.
  */
 
Index: uspace/lib/posix/errno.c
===================================================================
--- uspace/lib/posix/errno.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/errno.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file System error numbers.
  */
 
@@ -51,3 +51,2 @@
 /** @}
  */
-
Index: uspace/lib/posix/errno.h
===================================================================
--- uspace/lib/posix/errno.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/errno.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file System error numbers.
  */
 
@@ -325,3 +325,2 @@
 /** @}
  */
-
Index: uspace/lib/posix/fcntl.c
===================================================================
--- uspace/lib/posix/fcntl.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/fcntl.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file File control.
  */
 
Index: uspace/lib/posix/fcntl.h
===================================================================
--- uspace/lib/posix/fcntl.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/fcntl.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file File control.
  */
 
Index: uspace/lib/posix/float.h
===================================================================
--- uspace/lib/posix/float.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/float.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Floating type support.
  */
 
Index: uspace/lib/posix/fnmatch.c
===================================================================
--- uspace/lib/posix/fnmatch.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/fnmatch.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Filename-matching.
  */
 
@@ -45,4 +45,6 @@
 #include "internal/common.h"
 #include "fnmatch.h"
+
+// TODO: documentation
 
 #define INVALID_PATTERN -1
@@ -169,4 +171,10 @@
 };
 
+/**
+ * 
+ * @param key
+ * @param elem
+ * @return
+ */
 static int _class_compare(const void *key, const void *elem)
 {
@@ -175,4 +183,10 @@
 }
 
+/**
+ * 
+ * @param cname
+ * @param c
+ * @return
+ */
 static bool _is_in_class (const char *cname, int c)
 {
@@ -191,4 +205,11 @@
 }
 
+/**
+ * 
+ * @param pattern
+ * @param str
+ * @param flags
+ * @return
+ */
 static int _match_char_class(const char **pattern, const char *str, int flags)
 {
@@ -204,4 +225,10 @@
 /************** END CHARACTER CLASSES ****************/
 
+/**
+ * 
+ * @param pattern
+ * @param flags
+ * @return
+ */
 static _coll_elm_t _next_coll_elm(const char **pattern, int flags)
 {
@@ -240,5 +267,9 @@
 
 /**
- *
+ * 
+ * @param pattern
+ * @param str
+ * @param flags
+ * @return
  */
 static int _match_bracket_expr(const char **pattern, const char *str, int flags)
@@ -327,5 +358,9 @@
 
 /**
- *
+ * 
+ * @param pattern
+ * @param string
+ * @param flags
+ * @return
  */
 static bool _partial_match(const char **pattern, const char **string, int flags)
@@ -421,4 +456,11 @@
 }
 
+/**
+ * 
+ * @param pattern
+ * @param string
+ * @param flags
+ * @return
+ */
 static bool _full_match(const char *pattern, const char *string, int flags)
 {
@@ -476,4 +518,9 @@
 }
 
+/**
+ * 
+ * @param s
+ * @return
+ */
 static char *_casefold(const char *s)
 {
@@ -506,6 +553,10 @@
 
 	if ((flags & FNM_CASEFOLD) != 0) {
-		free((char *) pattern);
-		free((char *) string);
+		if (pattern) {
+			free((char *) pattern);
+		}
+		if (string) {
+			free((char *) string);
+		}
 	}
 
@@ -604,3 +655,2 @@
 /** @}
  */
-
Index: uspace/lib/posix/fnmatch.h
===================================================================
--- uspace/lib/posix/fnmatch.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/fnmatch.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Filename-matching.
  */
 
@@ -36,5 +36,5 @@
 #define POSIX_FNMATCH_H_
 
-/* Error Values. */
+/* Error Values */
 #undef FNM_NOMATCH
 #define FNM_NOMATCH 1
@@ -66,3 +66,2 @@
 /** @}
  */
-
